#include "link.h"
#include "paramSimul.h"


Link::Link()
{
	_2D_distance = new double*[num_bs];
	pathloss = new double*[num_bs];
	
	propagation_condition = new int*[num_bs];
	los = new bool*[num_bs];
	
	sigma_SF = new double*[num_bs];
	shadow_fading = new double*[num_bs];
	
	TLSPs = new ArrayXd*[num_bs];

	for(int bs_idx=0; bs_idx< num_bs ; bs_idx++)
	{
		_2D_distance[bs_idx] = new double[num_ue];
		pathloss[bs_idx] = new double[num_ue];
		
		propagation_condition[bs_idx] = new int[num_ue];
		los[bs_idx] = new bool[num_ue];

		sigma_SF[bs_idx] = new double[num_ue];
		shadow_fading[bs_idx] = new double[num_ue];
				
		TLSPs[bs_idx] = new ArrayXd[num_ue];
	}

}


Link::~Link()
{
	for (int bs_idx = 0; bs_idx< num_bs; bs_idx++)
	{
		delete[] _2D_distance[bs_idx];
		delete[] pathloss[bs_idx];

		delete[] propagation_condition[bs_idx];
		delete[] los[bs_idx];

		delete[] sigma_SF[bs_idx];
		delete[] shadow_fading[bs_idx];

		delete[] TLSPs[bs_idx];
	}
	delete[] _2D_distance;
	delete[] pathloss;

	delete[] propagation_condition;
	delete[] los;

	delete[] sigma_SF;
	delete[] shadow_fading;

	delete[] TLSPs;

}
