#include <stdio.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <string>
#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include <Eigen/Dense>
#include <unsupported/Eigen/MatrixFunctions>

using namespace Eigen;



void Set_simul_param(int argc, char *argv[]);
void Make_ue_sector_object(void);
void Set_test_environment(void);
void Set_antenna_configuration(void);
void Set_fastfading_param();
void Set_antenna_location_vector();
void Deploy_bs_ue(void);
void Configure_sector_ue(void);
void Calculate_angle_in_GCS(void);
void Generate_pathloss(void);
void Get_Couplingloss_CDF(void);
void Select_adjacent_sector(void);
void Collect_Couplingloss(void);
void Allocate_memory(void);
void Delete_memory(void);
void Generate_LSP(void);
void Generate_SSP(void);
void Scheduling(void);
void Attach_ue_to_sector();


int main(int argc, char *argv[])
{
	Set_simul_param(argc, argv);
	cout << "Set_simul_param" << endl;
	
	Set_test_environment();
	cout << "Set_test_environment" << endl;
	
	Set_antenna_configuration();
	cout << "Set_antenna_configuration" << endl;

	Set_fastfading_param();
	cout << "Set_fastfading_param" << endl;

	Make_ue_sector_object();
	cout << "Make_ue_sector_object" << endl;

	Allocate_memory();
	cout << "Allocate_memory" << endl;

	for (drop_idx = 0; drop_idx < num_drops; drop_idx++)
	{

		cout << "drop_idx : " << drop_idx+1 <<"/"<<num_drops<< endl;
		cout << endl;
		

		Configure_sector_ue();
		cout << "Configure_sector_ue" << endl;
		cout << endl;

		Set_antenna_location_vector();

		cout << "Deploy_bs_ue" << endl;
		cout << endl;
		Deploy_bs_ue();
		
		cout << "Calculate_angle_in_GCS" << endl;
		cout << endl;
		Calculate_angle_in_GCS();
		
		cout << "Generate_pathloss" << endl;
		cout << endl;
		Generate_pathloss();

	
		cout << "Generate_LSP..." << endl;
		cout<<endl;
		Generate_LSP();
	
		//Select_adjacent_sector();
		
		cout << "Generate_SSP..." << endl;
		
		Generate_SSP();
		cout << endl << endl;
		
		cout << "Attach_ue_to_sector..." << endl;

		Attach_ue_to_sector();

		

		Collect_Couplingloss();
		/*
		//for (t = 0; t < run_times; t++)
		//{
		//	/*
		//	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		//	{
		//		for (int adj_sec_idx = 0; adj_sec_idx < num_compute_coef; adj_sec_idx++)
		//		{
		//			for (int u = 0; u < num_rx_antenna_element; u++)
		//			{
		//				for (int s = 0; s < num_tx_antenna_element; s++)
		//				{
		//					ChannelSampleGeneration(ue_idx, u, s, adj_sec_idx);
		//				}
		//			}
		//		}
		//	}
		//	*/
		//	cout << "Scheduling..." << endl;
		//	for (int idx = 0; idx < num_sector; idx++)
		//	{
		//		Scheduling();		//pschedulewrite[rb_idx].ue_selected
		//	}
		//	cout << "end Scheduling..." << endl;
		//	

		//	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		//	{
		//		//ue[ue_idx].Update_Geometry();
		//	}
		//	
		//	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		//	{
		//		ue[ue_idx].Receive_UL();
		//	}//getchar();
		//	

		//}
		//
		cout << endl;

	}

	Get_Couplingloss_CDF();
	Delete_memory();
	
}


