#include <iostream>
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "const.h"
#include <complex>
#include "struct.h"
#include "objectBSSectorUe.h"

using namespace std;

LOCATION Transpose_LCS_to_GCS_location(double alpha, double beta, double gamma, LOCATION X);


void Set_antenna_location_vector()
{

	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		for (int mg = 0; mg < ue_antenna.Mg; mg++)
		{
			for (int ng = 0; ng < ue_antenna.Ng; ng++)
			{
				for (int m = 0; m<ue_antenna.M; m++)
				{
					for (int n = 0; n<ue_antenna.N; n++)
					{
						for (int p = 0; p<ue_antenna.P; p++)
						{
							ue[ue_idx].d_tx[m][n][p][mg][ng].x = 0;
							ue[ue_idx].d_tx[m][n][p][mg][ng].y = n * ue_antenna.dH + ng * ue_antenna.dgH;
							ue[ue_idx].d_tx[m][n][p][mg][ng].z = m * ue_antenna.dV + mg * ue_antenna.dgV;


							if (ue_antenna.Ng == 1)
							{
								ue[ue_idx].d_tx[m][n][p][mg][ng] = Transpose_LCS_to_GCS_location(ue[ue_idx].alpha, ue[ue_idx].beta, ue[ue_idx].gamma, ue[ue_idx].d_tx[m][n][p][mg][ng]);
								
							}
							else
							{
								if (ng == 0)
								{
									ue[ue_idx].d_tx[m][n][p][mg][ng] = Transpose_LCS_to_GCS_location(ue[ue_idx].alpha, ue[ue_idx].beta, ue[ue_idx].gamma, ue[ue_idx].d_tx[m][n][p][mg][ng]);
								}
								else
								{
									ue[ue_idx].d_tx[m][n][p][mg][ng] = Transpose_LCS_to_GCS_location(ue[ue_idx].alpha + PI, ue[ue_idx].beta, ue[ue_idx].gamma, ue[ue_idx].d_tx[m][n][p][mg][ng]);
								}

							}

						}

					}

				}
			}
		}
	}


	for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
	{
		for (int mg = 0; mg < bs_antenna.Mg; mg++)
		{
			for (int ng = 0; ng < bs_antenna.Ng; ng++)
			{
				for (int m = 0; m<bs_antenna.M; m++)
				{
					for (int n = 0; n<bs_antenna.N; n++)
					{
						for (int p = 0; p<bs_antenna.P; p++)
						{
							sector[sec_idx].d_rx[m][n][p][mg][ng].x = 0;
							sector[sec_idx].d_rx[m][n][p][mg][ng].y = n * bs_antenna.dH + ng * bs_antenna.dgH;
							sector[sec_idx].d_rx[m][n][p][mg][ng].z = m * bs_antenna.dV + mg * bs_antenna.dgV;

							sector[sec_idx].d_rx[m][n][p][mg][ng] = Transpose_LCS_to_GCS_location(sector[sec_idx].alpha, sector[sec_idx].beta, sector[sec_idx].gamma, sector[sec_idx].d_rx[m][n][p][mg][ng]);
							
						}
					}

				}

			}
		}

	}
}

LOCATION Transpose_LCS_to_GCS_location(double alpha, double beta, double gamma, LOCATION X)
{
	LOCATION Y;

	Y.x = cos(alpha)*cos(beta) * X.x + (cos(alpha)*sin(beta)*sin(gamma) - sin(alpha)*cos(gamma)) * X.y + (cos(alpha)*sin(beta)*cos(gamma) + sin(alpha)*sin(gamma)) * X.z;
	Y.y = sin(alpha)*cos(beta) * X.x + (sin(alpha)*sin(beta)*sin(gamma) + cos(alpha)*cos(gamma)) * X.y + (sin(alpha)*sin(beta)*cos(gamma) - cos(alpha)*sin(gamma)) * X.z;
	Y.z = -sin(beta)          * X.x + cos(beta)*sin(gamma)                                      * X.y + cos(beta)*cos(gamma)                                      * X.z;



	return Y;
}