#ifndef _STRUCT_H_
#define _STRUCT_H_

#include <complex>

using namespace std;

typedef struct
{
	int begin;
	int end;
	int number_of_rb;
} ALLOCATED_FREQ;

typedef struct
{
	double snr;
} LL_CURVE_LOOK;

typedef struct
{
	double x;
	double y;
	double z;
} LOCATION;

typedef struct
{
	double clu_power;
	double delay_time;
} CHANNEL;

// for ffr
typedef struct
{
	int ue_idx;
	double avr_esinr;
} SELECTED_UE;


typedef struct
{
	int ue_selected;
	int mcs_selected;
} SCHEDULE_DECISION;

typedef struct
{
	double phi;
	double theta;
} SPHERICAL_ANGLE;

typedef struct
{
	double phi;
	double theta;
} ANTENNA_FIELD;


typedef struct
{
	complex <double> phi;
	complex <double> theta;
} ANTENNA_FIELD_COMPLEX;



typedef struct
{
	double num_steering_azimuth_angle;
	double num_steering_zenith_angle;
	

	double zenith_steering_angle[4];
	double azimuth_steering_angle[8];

	complex<double> virtualization_weight[4][8][8][8]; // [vertical steering angle ][horizontal steering angle][vertical_element per port][horizontal_element per port]
	
} ANALOG_BEAM;

typedef struct
{
	int ue_azimuth;
	int ue_zenith;
	int ue_panel;
	int sector_azimuth;
	int sector_zenith;

} STEERING_IDX;


typedef struct
{
	double element_gain_dBi;

	int M, N, P, Mg, Ng;
	int Mp, Np,K,L;
	double dH, dV, dgV, dgH;
	double polarization[2];
	double mechanic_tilt;

	double electronic_tilt;

	int num_txru;
	
} ANTENNA;


typedef struct
{
	complex <double> theta_theta;
	complex <double> theta_phi;
	complex <double> phi_theta;
	complex <double> phi_phi;
	
} RANDOM_INITIAL_PHASE;

 
#endif
