#ifndef _UE_H_
#define _UE_H_
#include <vector>
#include <iostream>
#include <fstream>
#include "struct.h"
#include <Eigen/Dense>
#include "rvGenerater.h"
using namespace std;
using namespace Eigen;

class UE
{
public:
	UE();
	~UE();

	void Configure(int);
	void Allocate_memory(void);
	void Set_UE_speed_indoor_outdoor_state(void);
	void Set_2D_distance_indoor(void);
	void Calculate_O2I_penet_loss(double distance_indoor);
	void Set_car_penet_loss(void);
	void Set_h_UT(void);
	void Drop_ue_in_site(void);
	void Determine_LOS(int sec_idx);
	void Set_breakpoint_distance(int sec_idx);
	void Compute_PathLoss(int sec_idx);
	void Update_Geometry(void);
	void Receive_UL(void);
	void Find_Allocated_Rbs_Mcs(void);
	double Compute_Effective_Snr(void);
	
	double Get_SpectralEfficiency(double esinr, int mcs);
	double FER(double esinr, int mcs);
	
	double Update_Power_Control(int rb_idx);
	

	//void Update_Channel(void);
	//void Receive_UL();

	int sector_in_control;
	int zenith_steering_idx=0;
	int azimuth_steering_idx = 0;
	int panel_idx=0;
	

	int  *adj_bs;
	int site_idx;
	int floor_idx;
	double  h_UT;
	double  speed;
	double  v[3];
	
	int  ue_indoor_outdoor_state;
	int O2I_penetration_loss_model;
	double _2D_distance_indoor;
	double Pathloss_tw;
	double Pathloss_car;
	double couplingloss_dB;
	
	double alpha;
	double beta;
	double gamma;
	LOCATION d_tx[2][4][2][1][2];//  antenna element location vector [M][N][P][Mg][Ng] (max num)
	
	LOCATION location_in_site;
	LOCATION pos_indoor;



	vector  <int> rb_indices;
	double  geometry;
	double esinr;
	double spectralEfficiency;
	int mcs;
	
	int num_of_rbs;
	int info_bits;

	double HARQeSINR;
	double uplinkThroghput;


private:
	int     _ue_idx;

};

#endif
